//
//  InputView.h
//  GHMMCurveRecognition
//
//  Created by Marcelo Cicconet on 10/20/11.
//  Copyright 2011 Georgia Tech. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "Curve.h"
#import "ObjGHMM.h"
#import "RingBufferView.h"

@interface InputView : NSView {
    float viewWidth;
    float viewHeight;
    
    NSPoint viewOrigin;
    int maxPoints;
    int nPoints;
    float * xPoints;
    float * yPoints;
    int phase;
    int leftIndex;
    int rightIndex;
    int curveIndex;
    IBOutlet NSTextField * curveIndexTextField;
    int maxCurves;
    int nCurves;
    NSMutableArray * arrayOfCurves;
//    NSMutableArray * arrayOfCurves2;
    
    IBOutlet NSButton * buttonStart;
    IBOutlet NSButton * buttonTrim;
    IBOutlet NSButton * buttonRecord;
    IBOutlet NSButton * buttonTrain;
    IBOutlet NSButton * buttonTest;
    
    ObjGHMM * objGHMM;
//    ObjGHMM * objGHMM2;

    float * rsRingBufferX; // rs: re-sampled
    float * rsRingBufferY;
    int rsRingBufferLength;
    int nRsPoints; // num of resampled points
    float rsCurvePointsDistance;
    NSPoint lastRsPoint;
    
    IBOutlet RingBufferView * ringBufferView1;
    IBOutlet RingBufferView * ringBufferView2;
    IBOutlet RingBufferView * ringBufferView3;
    
    IBOutlet NSTextField * curveLengthTextField;
    IBOutlet NSTextField * maxCurveLengthTextField;
}

- (NSPoint)locationInViewOfEvent:(NSEvent *)theEvent;
- (IBAction)setLeftIndex:(id)sender;
- (IBAction)setRightIndex:(id)sender;
- (IBAction)start:(id)sender;
- (IBAction)trim:(id)sender;
- (IBAction)record:(id)sender;
- (IBAction)train:(id)sender;
- (IBAction)test:(id)sender;
- (void)compare;
- (void)resampleWithPoint:(NSPoint)thePoint;
- (float)distanceBetweenPointsP:(NSPoint)thePointP andQ:(NSPoint)thePointQ;

@end
