//
//  TestCurveView.m
//  GHMMGuiTest
//
//  Created by Marcelo Cicconet on 10/11/11.
//  Copyright 2011 Georgia Tech. All rights reserved.
//

#import "TestCurveView.h"

@implementation TestCurveView

- (NSRect)rectFromPoint:(NSPoint)point viewWidth:(CGFloat)viewWidth viewHeight:(CGFloat)viewHeight
{
    int radius = 2.0;
    return NSMakeRect(point.x*viewWidth-radius, point.y*viewHeight-radius, 2*radius, 2*radius);
}

- (id)initWithFrame:(NSRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {

    }
    
    return self;
}

- (void)setPoints:(double *)thePoints nPoints:(int)theNPoints
{
    nPoints = theNPoints;
    points = (double *)malloc(2*nPoints*sizeof(double));
    for (int i = 0; i < nPoints; i++) {
        points[2*i] = thePoints[2*i];
        points[2*i+1] = thePoints[2*i+1];
    }
}

- (void)setMaxStates1:(int *)theMaxStates
{
    maxStates1 = (int *)malloc(nPoints*sizeof(int));
    memcpy(maxStates1, theMaxStates, nPoints*sizeof(int));
}

- (void)setMaxStates2:(int *)theMaxStates
{
    maxStates2 = (int *)malloc(nPoints*sizeof(int));
    memcpy(maxStates2, theMaxStates, nPoints*sizeof(int));
}

- (void)dealloc
{
    free(points);
    [super dealloc];
}

- (void)drawRect:(NSRect)dirtyRect
{
    if (nPoints) {
        NSMutableDictionary * stringAttributes;
        stringAttributes = [NSMutableDictionary dictionary];
        [stringAttributes setObject:[NSFont fontWithName:@"Monaco" size:10] forKey:NSFontAttributeName];
        [stringAttributes setObject:[NSColor yellowColor] forKey:NSForegroundColorAttributeName];
        double w = dirtyRect.size.width;
        double h = dirtyRect.size.height;
        [[NSColor blackColor] set];
        [NSBezierPath fillRect:dirtyRect];
        [[NSColor yellowColor] set];
        for (int i = 0; i < nPoints; i++) {
        [[NSBezierPath bezierPathWithOvalInRect:[self rectFromPoint:NSMakePoint(points[2*i], points[2*i+1]) viewWidth:w viewHeight:h]] fill];
            if (maxStates1) {
                [[NSString stringWithFormat:@"%d", maxStates1[i]] drawAtPoint:NSMakePoint(points[2*i]*w, (points[2*i+1]+0.01)*h) withAttributes:stringAttributes];
            }
            if (maxStates2) {
                [[NSString stringWithFormat:@"%d", maxStates2[i]] drawAtPoint:NSMakePoint(points[2*i]*w, (points[2*i+1]-0.1)*h) withAttributes:stringAttributes];
            }
        }
    }
}

@end